<?php
/*
Category View
Version 2.1
by: SoLoGHoST
http://graphicsmayhem.com
Copyright 2009 Solomon Closson

Category.template.php
############################################
License Information:
Author Credits above must remain intact.
#############################################
Additional Notes:  Compatibility only with SMF 2.0.x!!
#############################################
*/

function template_categoryview()
{
	global $scripturl, $txt, $context, $modSettings, $settings;

	// Set the Layout for the Category...
	$modSettings['catview_layout'] = empty($context['cat_layout']) ? 0 : $context['cat_layout'];

	echo '<div style="padding: 3px;">', theme_linktree(), '</div>'; 
	
		if ($context['user']['is_admin'])
		echo '<div class="categoryframe floatright"><form method="post" action="' . $scripturl . '?category=' . $context['cat_id'] . '&sa=layout">
				<label class="smalltext">', $txt['catview_layout'], '</label><select name="layout">
				<option value="0"', ($context['cat_layout'] == 0 ? ' selected' : ''), '>' . $txt['catview_layout_default'] . '</option>
				<option value="1"', ($context['cat_layout'] == 1 ? ' selected' : ''), '>' . $txt['catview_layout_vbull'] . '</option>
				<option value="2"', ($context['cat_layout'] == 2 ? ' selected' : ''), '>' . $txt['catview_layout_phpbb'] . '</option>
				</select> &nbsp;<input type="submit" value="', $txt['catview_change'], '" />
			  </form></div><br/><br/>';
			
	echo '<div class="categoryframe tborder"><h3 class="catbg headerpadding">';

		if (!$context['user']['is_guest'])
			echo '
			<a class="floatright" href="', $scripturl, '?action=unread;c=', $context['cat_id'], '">', $txt['view_unread_category'], '</a>';
		echo '<center><a href="', $scripturl, '?category=', $context['cat_id'], '">', $context['category_name'], '</a></center></h3>';					

echo '<table cellspacing="1" cellspacing="0" class="bordercolor boardsframe" width="100%" align="center">';

	doLayout($modSettings['catview_layout']);

echo '</table></div><br/><div id="posticons" class="titlebg2 tborder clearfix marginbottom" style="padding-left: 10px; padding-right: 10px; padding-top: 5px;">

			<p class="floatright" id="message_index_jump_to">&nbsp;</p>';

	if ($context['user']['is_logged'])
	{
		echo '
		<div class="smalltext floatleft headerpadding">
			<img src="' . $settings['images_url'] . '/new_some.gif" alt="" align="middle" /> ', $txt['new_posts'], '
			<img src="' . $settings['images_url'] . '/new_none.gif" alt="" align="middle" style="margin-left: 4ex;" /> ', $txt['old_posts'], '
		</div>';
	}

	echo '
			<script language="JavaScript" type="text/javascript"><!-- // --><![CDATA[
				if (typeof(window.XMLHttpRequest) != "undefined")
					aJumpTo[aJumpTo.length] = new JumpTo({
						sContainerId: "message_index_jump_to",
						sJumpToTemplate: "<label class=\"smalltext\" for=\"%select_id%\">', $context['jump_to']['label'], ':<" + "/label> %dropdown_list%",
						iCurBoardId: "",
						iCurCatId: ', $context['cat_id'], ',
						sCurBoardName: "",
						sCurCatName: "', $context['jump_to']['category_name'], '",
						sBoardChildLevelIndicator: "==",
						sBoardPrefix: "=> ",
						sCatSeparator: "-----------------------------",
						sCatPrefix: "",
						sGoButtonLabel: "', $txt['go'], '"
					});
			// ]]></script>
		</div>';
}




function vBulletinLayout()
{
	global $scripturl, $txt, $context, $modSettings, $settings;

				echo '	<tr align="center" width="100%">
							<td width="6%" class="titlebg catHeaderPadding" style="font-weight: bold;"> </td>
							<td width="70%" class="titlebg" align="left" valign="middle" style="font-weight: bold;">', $txt['cat_boards'], '</td>
							<td width="12%" class="titlebg catHeaderPadding" valign="middle" style="text-align: center; font-weight: bold;">', $txt['cat_boards_last_post'], '</td>
							<td width="6%" class="titlebg catHeaderPadding" valign="middle" style="text-align: center; font-weight: bold;">', $txt['board_topics'], '</td>
							<td width="6%" class="titlebg catHeaderPadding" valign="middle" style="text-align: center; font-weight: bold;">', $txt['posts'], '</td>
						</tr>';

	foreach ($context['category_boards'] as $board)
	{
				echo '
			<tr align="center">
				<td class="windowbg" align="center" valign="middle" style="padding: 2px;" width="6%"', (!empty($board['children']) ? ' rowspan="2"' : ''), '>
					<a href="', ($board['is_redirect'] || $context['user']['is_guest'] ? $board['href'] : $scripturl . '?action=unread;board=' . $board['id'] . '.0;children'), '">';

				// If the board or children is new, show an indicator.
				if ($board['new'] || $board['children_new'])
					echo '
						<img src="', $settings['images_url'], '/on', $board['new'] ? '' : '2', '.gif" alt="', $txt['new_posts'], '" title="', $txt['new_posts'], '" border="0" />';
				// Is it a redirection board?
				elseif ($board['is_redirect'])
					echo '
						<img src="', $settings['images_url'], '/redirect.gif" alt="*" title="*" border="0" />';
				// No new posts at all! The agony!!
				else
					echo '
						<img src="', $settings['images_url'], '/off.gif" alt="', $txt['old_posts'], '" title="', $txt['old_posts'], '" />';

				echo '
					</a>
				</td>
				<td class="windowbg2" style="padding: 2px;">
				<div style="text-align:left;">
					<h4 style="text-align: left;"><a href="', $board['href'], '" name="b', $board['id'], '">', $board['name'], '</a>';

				// Has it outstanding posts for approval?
				if ($board['can_approve_posts'] && ($board['unapproved_posts'] || $board['unapproved_topics']))
					echo '
						<a href="', $scripturl, '?action=moderate;area=postmod;sa=', ($board['unapproved_topics'] > $board['unapproved_posts'] ? 'topics' : 'posts'), ';brd=', $board['id'], ';', $context['session_var'], '=', $context['session_id'], '" title="', sprintf($txt['unapproved_posts'], $board['unapproved_topics'], $board['unapproved_posts']), '" class="moderation_link">(!)</a>';

				echo '
					</h4></div>
					
					<div style="text-align: left;">', $board['description'], '</div>';

				// Show the "Moderators: ". Each has name, href, link, and id. (but we're gonna use link_moderators.)
				if (!empty($board['moderators']))
					echo '
					<div class="moderators" style="padding-top: 2px; text-align: left;">', count($board['moderators']) == 1 ? $txt['moderator'] : $txt['moderators'], ': ', implode(', ', $board['link_moderators']), '</div>';
				// Show some basic information about the number of posts, etc.
					echo '
				</td>';
				echo '<td', !empty($board['children']) ? ' rowspan="2"' : '', ' class="windowbg2 smalltext" style="font-size: 12px; text-align: left; padding: 2px;">';

					if (!empty($board['last_post']['id']))
						echo '<div align="left" style="font-size: 11px; color: #000000; text-align: left;">
							<div style="color: #000000; text-align: left;">
								<span style="white-space:nowrap; color: #000000; text-align: left;"><strong style="font-size:12px; white-space:nowrap;">', $board['last_post']['link'], '</strong></span>
							</div>
							<div style="white-space:nowrap">
								', $txt['by'], ' ', $board['last_post']['member']['link'], '
							</div>
							<div align="right" style="white-space:nowrap color: #000000;">', $board['last_post']['time'], '
							</div>
						</div>';
					else
						echo '<strong>', $txt['no_new_posts'], '</strong>';
					echo '
					</td>';
					// Show # of Topics
					echo '<td class="windowbg"', !empty($board['children']) ? ' rowspan="2"' : '', ' style="padding: 5px;">', $board['topics'], '</td>';
					// Show # of Posts
					echo '<td class="windowbg"', !empty($board['children']) ? ' rowspan="2"' : '', ' style="padding: 5px;">', $board['posts'], '</td>
			</tr>';
			
			
			// Show the "Child Boards: ". (there's a link_children but we're going to bold the new ones...)
				if (!empty($board['children']))
				{
					// Sort the links into an array with new boards bold so it can be imploded.
					$children = array();
					/* Each child in each board's children has:
							id, name, description, new (is it new?), topics (#), posts (#), href, link, and last_post. */
					foreach ($board['children'] as $child)
					{
						if (!$child['is_redirect'])
							$child['link'] = '<a href="' . $child['href'] . '" title="' . ($child['new'] ? $txt['new_posts'] : $txt['old_posts']) . ' (' . $txt['board_topics'] . ': ' . $child['topics'] . ', ' . $txt['posts'] . ': ' . $child['posts'] . ')">' . $child['name'] . '</a>';
						else
							$child['link'] = '<a href="' . $child['href'] . '" title="' . $child['posts'] . ' ' . $txt['redirects'] . '">' . $child['name'] . '</a>';

						// Has it posts awaiting approval?
						if ($child['can_approve_posts'] && ($child['unapproved_posts'] | $child['unapproved_topics']))
							$child['link'] .= ' <a href="' . $scripturl . '?action=moderate;area=postmod;sa=' . ($child['unapproved_topics'] > $child['unapproved_posts'] ? 'topics' : 'posts') . ';brd=' . $child['id'] . ';' . $context['session_var'] . '=' . $context['session_id'] . '" title="' . sprintf($txt['unapproved_posts'], $child['unapproved_topics'], $child['unapproved_posts']) . '" class="moderation_link">(!)</a>';

						$children[] = $child['new'] ? '<strong>' . $child['link'] . '</strong>' : $child['link'];
					}
					echo '
			<tr>
				<td class="windowbg3 smalltext smallpadding"><strong>', $txt['parent_boards'], '</strong>: ', implode(', ', $children), '</td>';
			echo '</tr>';
			}
	}
}

function SMFLayout()
{
	global $scripturl, $txt, $context, $modSettings, $settings;

	foreach ($context['category_boards'] as $board)
	{
				echo '
			<tr align="center">
				<td align="center" valign="middle" class="windowbg" width="6%" style="width: 6%; padding: 2px;"', (!empty($board['children']) ? ' rowspan="2"' : ''), '>
					<a href="', ($board['is_redirect'] || $context['user']['is_guest'] ? $board['href'] : $scripturl . '?action=unread;board=' . $board['id'] . '.0;children'), '">';

				// If the board or children is new, show an indicator.
				if ($board['new'] || $board['children_new'])
					echo '
						<img src="', $settings['images_url'], '/on', $board['new'] ? '' : '2', '.gif" alt="', $txt['new_posts'], '" title="', $txt['new_posts'], '" border="0" />';
				// Is it a redirection board?
				elseif ($board['is_redirect'])
					echo '
						<img src="', $settings['images_url'], '/redirect.gif" alt="*" title="*" border="0" />';
				// No new posts at all! The agony!!
				else
					echo '
						<img src="', $settings['images_url'], '/off.gif" alt="', $txt['old_posts'], '" title="', $txt['old_posts'], '" />';

				echo '
					</a>
				</td>
				<td width="58%" class="windowbg2" style="padding: 2px;">
				<div style="text-align:left;">
					<h4 style="text-align: left;"><a href="', $board['href'], '" name="b', $board['id'], '">', $board['name'], '</a>';

				// Has it outstanding posts for approval?
				if ($board['can_approve_posts'] && ($board['unapproved_posts'] || $board['unapproved_topics']))
					echo '
						<a href="', $scripturl, '?action=moderate;area=postmod;sa=', ($board['unapproved_topics'] > $board['unapproved_posts'] ? 'topics' : 'posts'), ';brd=', $board['id'], ';', $context['session_var'], '=', $context['session_id'], '" title="', sprintf($txt['unapproved_posts'], $board['unapproved_topics'], $board['unapproved_posts']), '" class="moderation_link">(!)</a>';

				echo '
					</h4></div>
					
					<div style="text-align: left;">', $board['description'], '</div>';

				// Show the "Moderators: ". Each has name, href, link, and id. (but we're gonna use link_moderators.)
				if (!empty($board['moderators']))
					echo '
					<div class="moderators" style="padding-top: 2px; text-align: left;">', count($board['moderators']) == 1 ? $txt['moderator'] : $txt['moderators'], ': ', implode(', ', $board['link_moderators']), '</div>';
				// Show some basic information about the number of posts, etc.
					echo '
				</td>';
				echo '
				<td', !empty($board['children']) ? ' rowspan="2"' : '', ' align="center" valign="middle" width="12%" class="windowbg smalltext" style="text-align: center; vertical-align: middle; padding: 5px;">
					', $board['posts'], ' ', $board['is_redirect'] ? $txt['redirects'] : $txt['posts'], ' <br />
					', $board['is_redirect'] ? '' : $board['topics'] . ' ' . $txt['board_topics'], '
				</td>
				<td', !empty($board['children']) ? ' rowspan="2"' : '', ' width="24%" class="windowbg2 smalltext" align="left" valign="middle" style="vertical-align: middle; padding: 2px; white-space:nowrap;">';

				/* The board's and children's 'last_post's have:
				time, timestamp (a number that represents the time.), id (of the post), topic (topic id.),
				link, href, subject, start (where they should go for the first unread post.),
				and member. (which has id, name, link, href, username in it.) */
				if (!empty($board['last_post']['id']))
					echo '
					<strong>', $txt['last_post'], '</strong>  ', $txt['by'], ' ', $board['last_post']['member']['link'] , '<br />
					', $txt['in'], ' ', $board['last_post']['link'], '<br />
					', $txt['on'], ' ', $board['last_post']['time'];
				echo '
					</td>
			</tr>';
			
				// Show the "Child Boards: ". (there's a link_children but we're going to bold the new ones...)
				if (!empty($board['children']))
				{
					// Sort the links into an array with new boards bold so it can be imploded.
					$children = array();
					/* Each child in each board's children has:
							id, name, description, new (is it new?), topics (#), posts (#), href, link, and last_post. */
					foreach ($board['children'] as $child)
					{
						if (!$child['is_redirect'])
							$child['link'] = '<a href="' . $child['href'] . '" title="' . ($child['new'] ? $txt['new_posts'] : $txt['old_posts']) . ' (' . $txt['board_topics'] . ': ' . $child['topics'] . ', ' . $txt['posts'] . ': ' . $child['posts'] . ')">' . $child['name'] . '</a>';
						else
							$child['link'] = '<a href="' . $child['href'] . '" title="' . $child['posts'] . ' ' . $txt['redirects'] . '">' . $child['name'] . '</a>';

						// Has it posts awaiting approval?
						if ($child['can_approve_posts'] && ($child['unapproved_posts'] | $child['unapproved_topics']))
							$child['link'] .= ' <a href="' . $scripturl . '?action=moderate;area=postmod;sa=' . ($child['unapproved_topics'] > $child['unapproved_posts'] ? 'topics' : 'posts') . ';brd=' . $child['id'] . ';' . $context['session_var'] . '=' . $context['session_id'] . '" title="' . sprintf($txt['unapproved_posts'], $child['unapproved_topics'], $child['unapproved_posts']) . '" class="moderation_link">(!)</a>';

						$children[] = $child['new'] ? '<strong>' . $child['link'] . '</strong>' : $child['link'];
					}
					echo '
			<tr>
				<td class="windowbg3 smalltext largepadding"><strong>', $txt['parent_boards'], '</strong>: ', implode(', ', $children), '</td>';

			echo '</tr>';
				}	
		}	
}

function phpBBLayout()
{
	global $scripturl, $txt, $context, $modSettings, $settings;

				echo '	<tr align="center">
							<td width="64%" class="titlebg catHeaderPadding" align="left" valign="middle" colspan="2" style="text-align: left; font-weight: bold;">', $txt['cat_boards'], '</td>
							<td width="6%" class="titlebg catHeaderPadding" align="center" valign="middle" style="text-align: center; font-weight: bold; width: 6%;">', $txt['board_topics'], '</td>
							<td width="6%" class="titlebg catHeaderPadding" align="center" valign="middle" width="6%" style="text-align: center; font-weight: bold; width: 6%;">', $txt['posts'], '</td>
							<td width="24%" class="titlebg catHeaderPadding" valign="middle" style="text-align: center; font-weight: bold; width: 24%;">', $txt['cat_boards_last_post'], '</td>
						</tr>
				';
	foreach ($context['category_boards'] as $board)
	{	
				echo '
			<tr align="center">
				<td align="center" valign="middle" class="windowbg" width="6%" style="padding: 2px">
					<a href="', ($board['is_redirect'] || $context['user']['is_guest'] ? $board['href'] : $scripturl . '?action=unread;board=' . $board['id'] . '.0;children'), '">';

				// If the board or children is new, show an indicator.
				if ($board['new'] || $board['children_new'])
					echo '
						<img src="', $settings['images_url'], '/on', $board['new'] ? '' : '2', '.gif" alt="', $txt['new_posts'], '" title="', $txt['new_posts'], '" border="0" />';
				// Is it a redirection board?
				elseif ($board['is_redirect'])
					echo '
						<img src="', $settings['images_url'], '/redirect.gif" alt="*" title="*" border="0" />';
				// No new posts at all! The agony!!
				else
					echo '
						<img src="', $settings['images_url'], '/off.gif" alt="', $txt['old_posts'], '" title="', $txt['old_posts'], '" />';

				echo '
					</a>
				</td>
				<td width="58%" class="windowbg2" align="left" valign="middle" style="padding: 2px 4px 2px 4px;">
					<h3><a href="', $board['href'], '" name="b', $board['id'], '">', $board['name'], '</a>';

				// Has it outstanding posts for approval?
				if ($board['can_approve_posts'] && ($board['unapproved_posts'] || $board['unapproved_topics']))
					echo '
						<a href="', $scripturl, '?action=moderate;area=postmod;sa=', ($board['unapproved_topics'] > $board['unapproved_posts'] ? 'topics' : 'posts'), ';brd=', $board['id'], ';', $context['session_var'], '=', $context['session_id'], '" title="', sprintf($txt['unapproved_posts'], $board['unapproved_topics'], $board['unapproved_posts']), '" class="moderation_link">(!)</a>';

				echo '
					</h3>
					<div class="mediumtext phpBBPadding">', $board['description'] , '</div>';

				// Show the "Moderators: ". Each has name, href, link, and id. (but we're gonna use link_moderators.)
				if (!empty($board['moderators']))
					echo '
					<div class="moderators smalltext phpBBPadding">', count($board['moderators']) == 1 ? $txt['moderator'] : $txt['moderators'], ': ', implode(', ', $board['link_moderators']), '</div>';


			// Show the "Child Boards: ". (there's a link_children but we're going to bold the new ones...)
				if (!empty($board['children']))
				{
					// Sort the links into an array with new boards bold so it can be imploded.
					$children = array();
					/* Each child in each board's children has:
							id, name, description, new (is it new?), topics (#), posts (#), href, link, and last_post. */
					foreach ($board['children'] as $child)
					{
						if (!$child['is_redirect'])
							$child['link'] = '<a href="' . $child['href'] . '" title="' . ($child['new'] ? $txt['new_posts'] : $txt['old_posts']) . ' (' . $txt['board_topics'] . ': ' . $child['topics'] . ', ' . $txt['posts'] . ': ' . $child['posts'] . ')">' . '<img src="' . $settings['images_url'] . '/' . ($child['new'] ? 'phpBB_childboard_unread.gif' : 'phpBB_childboard_read.gif') . '" width="11" height="9" border="0" /> ' . $child['name'] . '</a>';
						else
							$child['link'] = '<a href="' . $child['href'] . '" title="' . $child['posts'] . ' ' . $txt['redirects'] . '">' . $child['name'] . '</a>';

						// Has it posts awaiting approval?
						if ($child['can_approve_posts'] && ($child['unapproved_posts'] | $child['unapproved_topics']))
							$child['link'] .= ' <a href="' . $scripturl . '?action=moderate;area=postmod;sa=' . ($child['unapproved_topics'] > $child['unapproved_posts'] ? 'topics' : 'posts') . ';brd=' . $child['id'] . ';' . $context['session_var'] . '=' . $context['session_id'] . '" title="' . sprintf($txt['unapproved_posts'], $child['unapproved_topics'], $child['unapproved_posts']) . '" class="moderation_link">(!)</a>';

						$children[] = $child['new'] ? '<strong>' . $child['link'] . '</strong>' : $child['link'];
					}
					echo '
				<div class="windowbg2 smalltext phpBBPadding"><strong>', $txt['parent_boards'], '</strong>: ', implode(', ', $children), '</div>';					
				
				}
					echo '
				</td>';	
					// Show # of Topics
					echo '<td width="6%" class="windowbg" align="center" valign="middle" style="width: 6%; padding: 2px 4px 2px 4px;">', $board['topics'], '</td>';
					// Show # of Posts
					echo '<td width="6%" class="windowbg" align="center" valign="middle" style="width: 6%; padding: 2px 4px 2px 4px;">', $board['posts'], '</td>';
					
					echo '<td width="24%" class="windowbg2 mediumtext" style="white-space:nowrap; padding: 2px 4px 2px 4px;" align="left" valign="top">';
	
					if (!empty($board['last_post']['id']))
						echo '<span class="windowbg2">', $txt['by'], ' ', $board['last_post']['member']['link'], ' <a href="', $board['last_post']['href'], '" title="', $txt['phpBB_latest_post'], '"><img src="', $settings['images_url'], '/icons/last_post.gif" width="14" height="14" border="0" /></a></span><div class="windowbg2 lastpost">', $board['last_post']['time'], '</div>';
					else
						echo '<strong>', $txt['no_new_posts'], '</strong>';
					
					echo '
					</td>
			</tr>';					
			
	}		

}


function doLayout($layout = 0)
{
if ($layout == 0 || empty($layout))
	SMFLayout();
elseif ($layout == 1)
	vBulletinLayout();
elseif ($layout == 2)
	phpBBLayout();
}



?>